Program Gauss
! Program principal pt. ELIM
! Cu matricile: "A(n,n)" si "b(n,nb)"
! A. b: generate; citite din fisierul de intrare; sau: citite din din fisier extern.
!
! Ian.2013: 
! Afiseaza si (v. kod_Print):
! - matricile L,U
! - determinantul lui A
! - termenii liberi g
!
! Selectia fisierului de intrare - prin fereastra de dialog standard.
!
! Fisier de date (intrare/iesire):
! 1) Titlu
! 2) tip, kodInput
! 3) n, nb
! 4) [A] ... pentru kodA =1
! 5) [b] ... pentru kodA =1
! 6) kod_Inv, kod_PrintA, kod_PrintP
! 7) check_text
!
! Fisier extern (intrare):				
! 1) Titlu =linie text
! 2) Matricea A
! 3) vectorul/vectorii b

! Semnificatia:
! Titlu: text <= 80 caractere
!
! tip: text <= 10 caractere; primul e semnificativ: s, S =simetrica; alt caracter =generala;
!
! kodInput:     Matricie A si b:
!           0 = generate (de Gen_Ab);
!           1 = citite din fisier de intrare;
!           2 = citita din fiser extern (altul decat fisierul de intrare)
!           alta valoare = invalida

! n:  nr. de ecuatii;
! nb: nr. de termeni liberi.
!
! A: Matricea coeficientilor n x n
!    Tip "generala": Se scrie asa cum e data - pe linii si coloane
!    Tip "simetrica": se introduce triunghiul superior (pe linii).
!
! b: Termenii liberi
!    Se scriu pe linii: "nb" linii a "n" termeni liberi.
!
! kod_Inv: Cod_inversare_coeficienti
!	      kod_Inv: #0: a(i,j) -> 1./a(i,j)
! kodPrintA: cod tiparire matrici
!	kod_PrintA: #0: Se tiparesc matricile A si b
! kod_PrintP: cod_Tiparire
!	kod_PrintP: #0: Se tiparesc permutarile si pivotii.
!   kod_PrintP: >=2: Se tiparesc matricile "L" si "U"; si Determinantul.
!   kod_PrintP: >=3: Se tiparesc si termenii liberi "g". 
!   kod_PrintP: >=4: Se face proba: LU =A, sau A-permutat.
!
! Check_text: text <= 20 caractere. Primul caracter e semnificativ:
!	'C', 'c', 'P', 'p', 'F', 'f': se face proba "Ax-b" (pentru fiecare termen liber).
!   C,c, P, p: se tipareste diferenta maxima in modul "Ax-b"
!
!   F,f: - se tiparesc diferentele "Ax-b";
!
use ifwin

real, allocatable :: A(:,:), B(:,:)
character(260) fname, fname2, titlu*80

real prag /1E-6/	! Curent /1E-6/; Pentru test matrice singulara:/1E-7/ sau /1E-8/; Prag pentru Pivot ~0.
integer width

real, allocatable :: a0(:,:), b0(:,:)

character(20) check_text
logical do_check, full_check 

character(80) dummy
character(40) text
character(10) tip    ! gen/sim

integer status
real, allocatable :: xLU(:), row(:), col(:)
logical simetric, general

! Selecteza fisierul de intrare:
call GetFile(fname, status, 'Select Input File'C)

open(1, file =fname, status ='old', form ='formatted')

! citeste:
read(1,'(a)') TITLU

! Matricea A:
read(1,*) tip, kodInput
! Verifica kodInput:
if(Input_Check(kodInput) <0) goto 510


read(1,*) n, nb
allocate (A(n,n), b(n,nb))
A =0.; b =0.;

simetric =tip(1:1) =='s' .or. tip(1:1) =='S'
general =.not. simetric

If_2: IF(kodInput ==2) THEN
	call GetFile(fname2, status, 'Select Ab-Matrices File'C)
	open(2, file =fname2, status ='old', form ='formatted')
ENDIF If_2

! Citeste/Genereaza:
call Read_Ab(n, nb, A, b, general, kodInput)

! citeste coduri:
read(1,*) kod_Inv, kod_PrintA, kod_PrintP

! citeste "Proba"
read(1,*) check_text

full_check =check_text(1:1) =='F' .or. check_text(1:1) =='f'

do_check =check_text(1:1) =='C' .or. check_text(1:1) =='c' &
	 .or. check_text(1:1) =='P' .or. check_text(1:1) =='p' &
	 .or. full_check

if(kod_Inv /=0) then
!do i=1,n
!do j=1,n
!a(i,j) =1./a(i,j)
!enddo
!enddo
A =1./A
endif

! 
if(kod_PrintA /=0) then
! write A:
write(1,'(/,a)') 'Matricea A'
	do i =1,n
	write(1,*) (a(i,j), j= 1,n)
	enddo

! write b:
write(1,'(/,a)') 'Termenii liberi b'

	do i =1,n
	write(1,*) (b(i,j), j= 1,nb)
	enddo

endif

! Pt. Proba:
if(do_check) then
allocate(a0(n,n), b0(n,nb))
a0 =a; b0 =b;
endif

n_sch_linii =0
	call ELIM(n, nb, A, B, prag, kod, kod_PrintP, n_sch_linii)

if(kod <0) then
write(1, '(/, a, 1pE8.2,a, /,a)') '* Pivot <', prag,' !',&
'* Sistemul nu se poate rezolva.'

write(*, '(/, a, 1pE8.2,a, /,a)') '* Pivot <', prag,' !',&
'* Sistemul nu se poate rezolva.'

goto 500
endif

! Nr. schimb. de linii:
if(kod_PrintP /=0) then
i_nsl =width(n_sch_linii)
write(1,'(/,a, I<i_nsl>)') 'Nr. de pivotari: ', n_sch_linii
endif

! Matricile L si U ~ A:
Print_LU_Det: if(kod_PrintP >=2) then
write(1,'(/,a)') 'Matricea "L":'
	do i =1,n
	write(1,*) a(i,1:i-1), 1.E0
	enddo
	
write(1,'(/,a)') 'Matricea "U":'
	do i =1,n
	write(1,*) a(i,i:n)
	enddo

det =1.

do i=1,n
det =det*a(i,i)
enddo

!det =det*(-1)**n_sch_linii
if(mod(n_sch_linii,2) /=0) then
det =-det
endif
write(1,'(/,a, 1pE14.6)') 'Determinant(A) =', det

endif Print_LU_Det

! write b:
Print_g: if(kod_PrintP >=3) then
write(1,'(/,a)') 'Termenii liberi "g":'

	do i =1,n
	write(1,*) b(i,1:nb)
	enddo
endif Print_g

Print_LU: if(kod_PrintP >=4) then
allocate(xLU(n), row(n), col(n))
xLU =0; row =0.; col =0;


if(n_sch_linii ==0) then
write(1,'(/,a)') ' * Proba L*U =A:'
else
write(1,'(/,a)') ' * Proba L*U =A-permutat:'
endif

if(kod_Inv ==0) then
write(1, '(a)') '   Matricea L*U'
else
write(1, '(a)') '   Matricea 1./L*U'
endif

do i =1,n
if(i >=2) row(1:i-1) =a(i,1:i-1); 
row(i) =1.; row(i+1:n) =0;

xLU =0.
    do j=1,n
    col(1:j) =a(1:j,j); col(j+1:n) =0.;

    kij =min(i,j)
    xLU(j) =DOT_PRODUCT(row(:kij), col(:kij))
    enddo

!write(1,*) xLU(:)    	
if(kod_Inv ==0) then
write(1,*) xLU(:)    	
else
write(1,*) 1./xLU(:)    	
endif

enddo
endif Print_LU


! SOLUTIA:
iwnb =width(nb)
write(1, '(a)')

nb_do: do k =1,nb
write(1, '(/, a, I<iwnb>)') ' * Solutia pentru termenii liberi nr. ', k

	n_do: do i=1,n
	iwi =width(i)
	write(1, '(a, I<iwi>, a, G15.7)') ' x(', i, ') = ', B(i,k)
	enddo n_do
enddo nb_do


! Proba: Solutia
CHECK_IF: IF(do_check) THEN

call Proba(n, nb, a0, b0, b, full_check)

ENDIF CHECK_IF


500 deallocate(A, b)
if(allocated(a0)) deallocate(a0)
if(allocated(b0)) deallocate(b0)

510 continue
END Program Gauss

